"use strict";
// Copyright (c) Jupyter Development Team.
// Distributed under the terms of the Modified BSD License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var coreutils_1 = require("@jupyterlab/coreutils");
var base_1 = require("@jupyter-widgets/base");
// TODO: import from @jupyter-widgets/jupyterlab-manager once Output is
// exported by the main module.
var output_1 = require("@jupyter-widgets/jupyterlab-manager/lib/output");
var widget_1 = require("./widget");
var version_1 = require("./version");
require("../css/sidecar.css");
var EXTENSION_ID = '@jupyter-widgets/jupyterlab-sidecar';
/**
 */
var sidecarPlugin = {
    id: EXTENSION_ID,
    requires: [base_1.IJupyterWidgetRegistry],
    activate: activateWidgetExtension,
    autoStart: true
};
exports.default = sidecarPlugin;
/**
 * Activate the widget extension.
 */
function activateWidgetExtension(app, registry) {
    var SidecarView = (function (_super) {
        __extends(class_1, _super);
        function class_1() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        class_1.prototype.render = function () {
            if (!this.model.rendered) {
                _super.prototype.render.call(this);
                var w = this._outputView;
                w.addClass('jupyterlab-sidecar');
                w.addClass('jp-LinkedOutputView');
                w.title.label = this.model.get('title');
                w.title.closable = true;
                app.shell['_rightHandler'].sideBar.tabCloseRequested.connect(function (sender, tab) {
                    tab.title.owner.dispose();
                });
                w.id = coreutils_1.uuid();
                if (Object.keys(this.model.views).length > 1) {
                    w.node.style.display = 'none';
                    var key = Object.keys(this.model.views)[0];
                    this.model.views[key].then(function (v) {
                        v._outputView.activate();
                    });
                }
                else {
                    app.shell.addToRightArea(w);
                    app.shell.expandRight();
                }
                var that = this;
            }
        };
        return class_1;
    }(output_1.OutputView));
    registry.registerWidget({
        name: '@jupyter-widgets/jupyterlab-sidecar',
        version: version_1.EXTENSION_SPEC_VERSION,
        exports: {
            SidecarModel: widget_1.SidecarModel,
            SidecarView: SidecarView
        }
    });
}
//# sourceMappingURL=plugin.js.map